Modify

Opened 4 months ago

Closed 4 months ago

Last modified 4 months ago

#21803 closed defect (fixed)

NoClassDefFoundError: Could not initialize class org.geotools.referencing.cs.DefaultCoordinateSystemAxis

Reported by: skyper Owned by: Don-vip
Priority: normal Milestone:
Component: Plugin geotools Version:
Keywords: template_report Cc:

Description

What steps will reproduce the problem?

  1. Start new josm latest today, which automatically updates my plugins
  2. Problem with updating geotools
  3. Keep plugin
  4. Open preferences
  5. Disable and enable geotools
  6. Update plugins
  7. All plugins are up-to-date
  8. Restart JOSM
  9. The problem persists


What is the expected result?

No exception and a working plugin

What happens instead?

Exception, have not tested funtionality

Please provide any additional information below. Attach a screenshot if possible.

Relative:URL: ^/trunk
Repository:UUID: 0c6e7542-c601-0410-84e7-c038aed88b3b
Last:Changed Date: 2022-01-25 19:05:27 +0100 (Tue, 25 Jan 2022)
Revision:18365
Build-Date:2022-01-26 02:31:12
URL:https://josm.openstreetmap.de/svn/trunk

Identification: JOSM/1.5 (18365 en) Linux Debian GNU/Linux 11 (bullseye)
Java version: 17.0.2+8-Debian-1deb11u1, Debian, OpenJDK 64-Bit Server VM
Look and Feel: com.formdev.flatlaf.FlatDarculaLaf
Environment variable LANG: en_US.utf8
System property file.encoding: UTF-8
System property sun.jnu.encoding: UTF-8
Locale info: en_US
Desktop environment: GNOME
libcommons-compress-java: libcommons-compress-java:all-1.20-1
libcommons-logging-java: libcommons-logging-java:all-1.2-2
fonts-noto: fonts-noto:all-20201225-1
VM arguments: [--module-path=/usr/share/openjfx/lib, --add-modules=java.scripting,java.sql,javafx.controls,javafx.media,javafx.swing,javafx.web, -Djosm.restart=true, -Djosm.dir.name=JOSM-latest, -Djava.net.useSystemProxies=true, --add-exports=java.base/sun.security.action=ALL-UNNAMED, --add-exports=java.desktop/com.sun.imageio.plugins.jpeg=ALL-UNNAMED, --add-exports=java.desktop/com.sun.imageio.spi=ALL-UNNAMED]

Plugins:
+ ImproveWay (32)
+ apache-commons (35893)
+ conflation (0.6.9)
+ contourmerge (v0.1.8)
+ editgpx (35893)
+ ejml (35893)
+ flatlaf (35862)
+ geotools
+ gridify (1606242219)
+ imagery_offset_db (35893)
+ jaxb (35893)
+ jts (35893)
+ opendata (35899)
+ photoadjust (35893)
+ pt_assistant (1ff2e15)
+ reverter (35893)
+ terracer (35893)
+ undelete (35893)
+ utilsplugin2 (35893)

Last errors/warnings:
- 00024.236 E: org.openstreetmap.josm.plugins.PluginException: An error occurred in plugin geotools. Cause: java.lang.reflect.InvocationTargetException. Cause: java.lang.NoClassDefFoundError: Could not initialize class org.geotools.referencing.cs.DefaultCoordinateSystemAxis
- 00024.269 W: Disable plugin - Could not load plugin 'geotools'. Delete from preferences?
- 00030.825 E: Failed to locate image 'bus.png'
2022-01-26 15:18:17.815 INFO: Warp/affine reduction enabled: true
Error in registry file at line number #4
org.jaitools.media.jai.contour.ContourDescriptor
Error in registry file at line number #5
org.jaitools.media.jai.rangelookup.RangeLookupDescriptor
Error in registry file at line number #6
org.jaitools.media.jai.vectorbinarize.VectorBinarizeDescriptor
Error in registry file at line number #7
org.jaitools.media.jai.vectorize.VectorizeDescriptor
Error in registry file at line number #16
org.jaitools.media.jai.contour.ContourRIF
Error in registry file at line number #17
org.jaitools.media.jai.rangelookup.RangeLookupRIF
Error in registry file at line number #18
org.jaitools.media.jai.vectorbinarize.VectorBinarizeRIF
Error in registry file at line number #19
org.jaitools.media.jai.vectorize.VectorizeRIF
2022-01-26 15:18:18.647 WARNING: Can't load a service for category "CRSAuthorityFactory". Cause is "ServiceConfigurationError: org.opengis.referencing.crs.CRSAuthorityFactory: Provider org.geotools.referencing.factory.epsg.CartesianAuthorityFactory could not be instantiated".
java.util.ServiceConfigurationError: org.opengis.referencing.crs.CRSAuthorityFactory: Provider org.geotools.referencing.factory.epsg.CartesianAuthorityFactory could not be instantiated
	at java.base/java.util.ServiceLoader.fail(ServiceLoader.java:586)
	at java.base/java.util.ServiceLoader$ProviderImpl.newInstance(ServiceLoader.java:813)
	at java.base/java.util.ServiceLoader$ProviderImpl.get(ServiceLoader.java:729)
	at java.base/java.util.ServiceLoader$3.next(ServiceLoader.java:1403)
	at org.geotools.util.factory.FactoryRegistry.register(FactoryRegistry.java:967)
	at org.geotools.util.factory.FactoryRegistry.scanForPlugins(FactoryRegistry.java:873)
	at org.geotools.util.factory.FactoryRegistry.scanForPluginsIfNeeded(FactoryRegistry.java:903)
	at org.geotools.util.factory.FactoryRegistry.getFactories(FactoryRegistry.java:265)
	at org.geotools.referencing.ReferencingFactoryFinder.getFactories(ReferencingFactoryFinder.java:183)
	at org.geotools.referencing.ReferencingFactoryFinder.getCRSAuthorityFactories(ReferencingFactoryFinder.java:453)
	at org.geotools.referencing.DefaultAuthorityFactory.getBackingFactory(DefaultAuthorityFactory.java:83)
	at org.geotools.referencing.DefaultAuthorityFactory.<init>(DefaultAuthorityFactory.java:63)
	at org.geotools.referencing.CRS.getAuthorityFactory(CRS.java:235)
	at org.geotools.referencing.CRS.decode(CRS.java:507)
	at org.geotools.referencing.CRS.decode(CRS.java:428)
	at org.openstreetmap.josm.plugins.geotools.GeoToolsPlugin.checkEPSG(GeoToolsPlugin.java:102)
	at org.openstreetmap.josm.plugins.geotools.GeoToolsPlugin.<init>(GeoToolsPlugin.java:37)
	at java.base/jdk.internal.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)
	at java.base/jdk.internal.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:77)
	at java.base/jdk.internal.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)
	at java.base/java.lang.reflect.Constructor.newInstanceWithCaller(Constructor.java:499)
	at java.base/java.lang.reflect.Constructor.newInstance(Constructor.java:480)
	at org.openstreetmap.josm.plugins.PluginInformation.load(PluginInformation.java:383)
	at org.openstreetmap.josm.plugins.PluginHandler.loadPlugin(PluginHandler.java:812)
	at org.openstreetmap.josm.plugins.PluginHandler.loadPlugins(PluginHandler.java:897)
	at org.openstreetmap.josm.plugins.PluginHandler.loadLatePlugins(PluginHandler.java:949)
	at org.openstreetmap.josm.gui.MainApplication.loadLatePlugins(MainApplication.java:1227)
	at org.openstreetmap.josm.gui.MainApplication.mainJOSM(MainApplication.java:957)
	at org.openstreetmap.josm.gui.MainApplication$3.processArguments(MainApplication.java:282)
	at org.openstreetmap.josm.gui.MainApplication.main(MainApplication.java:742)
Caused by: java.lang.ExceptionInInitializerError
	at si.uom.NonSI.<clinit>(NonSI.java:128)
	at org.geotools.referencing.cs.DefaultCoordinateSystemAxis.<clinit>(DefaultCoordinateSystemAxis.java:107)
	at org.geotools.referencing.cs.AbstractCS.<clinit>(AbstractCS.java:79)
	at org.geotools.referencing.crs.DefaultEngineeringCRS.<clinit>(DefaultEngineeringCRS.java:78)
	at org.geotools.referencing.factory.epsg.CartesianAuthorityFactory.<clinit>(CartesianAuthorityFactory.java:54)
	at java.base/jdk.internal.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)
	at java.base/jdk.internal.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:77)
	at java.base/jdk.internal.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)
	at java.base/java.lang.reflect.Constructor.newInstanceWithCaller(Constructor.java:499)
	at java.base/java.lang.reflect.Constructor.newInstance(Constructor.java:480)
	at java.base/java.util.ServiceLoader$ProviderImpl.newInstance(ServiceLoader.java:789)
	... 28 more
Caused by: java.lang.IllegalArgumentException: NumberSystem tech.units.indriya.function.DefaultNumberSystem not found
	at tech.units.indriya.function.Calculus.getNumberSystem(Calculus.java:118)
	at tech.units.indriya.function.Calculus.currentNumberSystem(Calculus.java:90)
	at tech.units.indriya.AbstractUnit.divide(AbstractUnit.java:477)
	at tech.units.indriya.AbstractUnit.divide(AbstractUnit.java:368)
	at tech.units.indriya.unit.Units.<clinit>(Units.java:231)
	... 39 more

2022-01-26 15:18:19.378 SEVERE: org.openstreetmap.josm.plugins.PluginException: An error occurred in plugin geotools. Cause: java.lang.reflect.InvocationTargetException. Cause: java.lang.NoClassDefFoundError: Could not initialize class org.geotools.referencing.cs.DefaultCoordinateSystemAxis
org.openstreetmap.josm.plugins.PluginException: An error occurred in plugin geotools
	at org.openstreetmap.josm.plugins.PluginInformation.load(PluginInformation.java:388)
	at org.openstreetmap.josm.plugins.PluginHandler.loadPlugin(PluginHandler.java:812)
	at org.openstreetmap.josm.plugins.PluginHandler.loadPlugins(PluginHandler.java:897)
	at org.openstreetmap.josm.plugins.PluginHandler.loadLatePlugins(PluginHandler.java:949)
	at org.openstreetmap.josm.gui.MainApplication.loadLatePlugins(MainApplication.java:1227)
	at org.openstreetmap.josm.gui.MainApplication.mainJOSM(MainApplication.java:957)
	at org.openstreetmap.josm.gui.MainApplication$3.processArguments(MainApplication.java:282)
	at org.openstreetmap.josm.gui.MainApplication.main(MainApplication.java:742)
Caused by: java.lang.reflect.InvocationTargetException
	at java.base/jdk.internal.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)
	at java.base/jdk.internal.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:77)
	at java.base/jdk.internal.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)
	at java.base/java.lang.reflect.Constructor.newInstanceWithCaller(Constructor.java:499)
	at java.base/java.lang.reflect.Constructor.newInstance(Constructor.java:480)
	at org.openstreetmap.josm.plugins.PluginInformation.load(PluginInformation.java:383)
	... 7 more
Caused by: java.lang.NoClassDefFoundError: Could not initialize class org.geotools.referencing.cs.DefaultCoordinateSystemAxis
	at org.geotools.referencing.factory.TransformedAuthorityFactory.<clinit>(TransformedAuthorityFactory.java:105)
	at org.geotools.referencing.factory.epsg.DirectEpsgFactory.<init>(DirectEpsgFactory.java:525)
	at org.geotools.referencing.factory.epsg.FactoryUsingSQL.<init>(FactoryUsingSQL.java:51)
	at org.geotools.referencing.factory.epsg.FactoryUsingAnsiSQL.<init>(FactoryUsingAnsiSQL.java:119)
	at org.geotools.referencing.factory.epsg.hsql.FactoryUsingHSQL.<init>(FactoryUsingHSQL.java:51)
	at org.geotools.referencing.factory.epsg.hsql.ThreadedHsqlEpsgFactory$1.<init>(ThreadedHsqlEpsgFactory.java:322)
	at org.geotools.referencing.factory.epsg.hsql.ThreadedHsqlEpsgFactory.createBackingStore(ThreadedHsqlEpsgFactory.java:322)
	at org.geotools.referencing.factory.epsg.ThreadedEpsgFactory.createBackingStore0(ThreadedEpsgFactory.java:393)
	at org.geotools.referencing.factory.epsg.ThreadedEpsgFactory.createBackingStore(ThreadedEpsgFactory.java:435)
	at org.geotools.referencing.factory.DeferredAuthorityFactory.getBackingStore(DeferredAuthorityFactory.java:114)
	at org.geotools.referencing.factory.BufferedAuthorityFactory.isAvailable(BufferedAuthorityFactory.java:245)
	at org.geotools.referencing.factory.DeferredAuthorityFactory.isAvailable(DeferredAuthorityFactory.java:100)
	at org.geotools.util.factory.FactoryRegistry.isAvailable(FactoryRegistry.java:761)
	at org.geotools.util.factory.FactoryRegistry.isAcceptable(FactoryRegistry.java:584)
	at org.geotools.util.factory.FactoryRegistry.lambda$getFactoryImplementation$2(FactoryRegistry.java:518)
	at java.base/java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:178)
	at java.base/java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:179)
	at java.base/java.util.Spliterators$IteratorSpliterator.tryAdvance(Spliterators.java:1856)
	at java.base/java.util.stream.ReferencePipeline.forEachWithCancel(ReferencePipeline.java:129)
	at java.base/java.util.stream.AbstractPipeline.copyIntoWithCancel(AbstractPipeline.java:527)
	at java.base/java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:513)
	at java.base/java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:499)
	at java.base/java.util.stream.FindOps$FindOp.evaluateSequential(FindOps.java:150)
	at java.base/java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)
	at java.base/java.util.stream.ReferencePipeline.findFirst(ReferencePipeline.java:647)
	at org.geotools.util.factory.FactoryRegistry.getFactoryImplementation(FactoryRegistry.java:519)
	at org.geotools.util.factory.FactoryRegistry.getFactory(FactoryRegistry.java:434)
	at org.geotools.util.factory.FactoryCreator.getFactory(FactoryCreator.java:138)
	at org.geotools.referencing.ReferencingFactoryFinder.getAuthorityFactory(ReferencingFactoryFinder.java:223)
	at org.geotools.referencing.ReferencingFactoryFinder.getCRSAuthorityFactory(ReferencingFactoryFinder.java:438)
	at org.geotools.referencing.factory.epsg.LongitudeFirstFactory.createBackingStore(LongitudeFirstFactory.java:165)
	at org.geotools.referencing.factory.DeferredAuthorityFactory.getBackingStore(DeferredAuthorityFactory.java:114)
	at org.geotools.referencing.factory.BufferedAuthorityFactory.isAvailable(BufferedAuthorityFactory.java:245)
	at org.geotools.referencing.factory.DeferredAuthorityFactory.isAvailable(DeferredAuthorityFactory.java:100)
	at org.geotools.util.factory.FactoryRegistry.isAvailable(FactoryRegistry.java:761)
	at org.geotools.util.factory.FactoryRegistry.isAcceptable(FactoryRegistry.java:584)
	at org.geotools.util.factory.FactoryRegistry.lambda$getFactories$0(FactoryRegistry.java:267)
	at java.base/java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:178)
	at java.base/java.util.Spliterators$IteratorSpliterator.tryAdvance(Spliterators.java:1856)
	at java.base/java.util.stream.StreamSpliterators$WrappingSpliterator.lambda$initPartialTraversalState$0(StreamSpliterators.java:292)
	at java.base/java.util.stream.StreamSpliterators$AbstractWrappingSpliterator.fillBuffer(StreamSpliterators.java:206)
	at java.base/java.util.stream.StreamSpliterators$AbstractWrappingSpliterator.doAdvance(StreamSpliterators.java:161)
	at java.base/java.util.stream.StreamSpliterators$WrappingSpliterator.tryAdvance(StreamSpliterators.java:298)
	at java.base/java.util.Spliterators$1Adapter.hasNext(Spliterators.java:681)
	at org.geotools.util.LazySet.size(LazySet.java:91)
	at java.base/java.util.AbstractCollection.toArray(AbstractCollection.java:141)
	at java.base/java.util.ArrayList.<init>(ArrayList.java:181)
	at org.geotools.referencing.DefaultAuthorityFactory.getBackingFactory(DefaultAuthorityFactory.java:90)
	at org.geotools.referencing.DefaultAuthorityFactory.<init>(DefaultAuthorityFactory.java:63)
	at org.geotools.referencing.CRS.getAuthorityFactory(CRS.java:235)
	at org.geotools.referencing.CRS.decode(CRS.java:507)
	at org.geotools.referencing.CRS.decode(CRS.java:428)
	at org.openstreetmap.josm.plugins.geotools.GeoToolsPlugin.checkEPSG(GeoToolsPlugin.java:102)
	at org.openstreetmap.josm.plugins.geotools.GeoToolsPlugin.<init>(GeoToolsPlugin.java:37)
	... 13 more

2022-01-26 15:18:19.464 WARNING: Disable plugin - Could not load plugin 'geotools'. Delete from preferences?

Attachments (0)

Change History (21)

comment:1 Changed 4 months ago by taylor.smock

Ticket #21799 has been marked as a duplicate of this ticket.

comment:2 Changed 4 months ago by skyper

Ticket #21804 has been marked as a duplicate of this ticket.

comment:3 Changed 4 months ago by taylor.smock

OK. This particular bug is from Java 17. Java 11 is not affected.

I'm guessing this is due to JEP 403. This is going to be fun to debug.

EDIT: It looks like it didn't crash on Java 11 since I had a debugger point prior to the crash location.

Last edited 4 months ago by taylor.smock (previous) (diff)

comment:4 Changed 4 months ago by marcello@…

Dunno. I had Java 17 for some time now and it did not happen before today. OTOH @18365 does things with projections.

comment:5 Changed 4 months ago by skyper

I have the identical problem with java 11. After deleting the the plugin .jar file and downloading/installing it again, still the same.

Java version: 11.0.14+9-post-Debian-1deb11u1, Debian, OpenJDK 64-Bit Server VM

We have reports with tested (r18360).

comment:6 Changed 4 months ago by taylor.smock

I think it is probably something that is keeping us from loading the DefaultNumberSystem in indriya.
Caused by: java.lang.IllegalArgumentException: NumberSystem tech.units.indriya.function.DefaultNumberSystem not found.

It looks like the META-INF/services folder isn't being copied from the indriya jar file.

EDIT: I'll get a fix out that is specific to DefaultNumberSystem in the next hour or so (build times for geotools is a bit long).
@Don-vip: Do you remember why you excluded META-INF/**/*?

Last edited 4 months ago by taylor.smock (previous) (diff)

comment:7 Changed 4 months ago by taylor.smock

Resolution: fixed
Status: newclosed

In 35901/osm:

Fix #21803: NumberSystem tech.units.indriya.function.DefaultNumberSystem not found

This is caused by excluding all META-INF files from the library jar files.
This patch explicitely keeps META-INF/services files from the following organizations:

  • tech.units.indriya.spi.NumberSystem (this is what fixes #21803)
  • org.geotools
  • org.opengis

comment:8 Changed 4 months ago by taylor.smock

In 35902/osm:

dist (geotools)

see #21803: NumberSystem tech.units.indriya.function.DefaultNumberSystem not found

This is caused by excluding all META-INF files from the library jar files.
The patch explicitely kept META-INF/services files from the following organizations:

  • tech.units.indriya.spi.NumberSystem (this is what fixes #21803)
  • org.geotools
  • org.opengis

comment:9 Changed 4 months ago by anonymous

Also attempted to get the new plugins and I get a slightly different error now:

2022-01-27 08:47:42.665 INFO: loading plugin 'geotools' (version 35901)
2022-01-27 08:47:43.039 INFO: Warp/affine reduction enabled: true
Error in registry file at line number #4
org.jaitools.media.jai.contour.ContourDescriptor
Error in registry file at line number #5
org.jaitools.media.jai.rangelookup.RangeLookupDescriptor
Error in registry file at line number #6
org.jaitools.media.jai.vectorbinarize.VectorBinarizeDescriptor
Error in registry file at line number #7
org.jaitools.media.jai.vectorize.VectorizeDescriptor
Error in registry file at line number #16
org.jaitools.media.jai.contour.ContourRIF
Error in registry file at line number #17
org.jaitools.media.jai.rangelookup.RangeLookupRIF
Error in registry file at line number #18
org.jaitools.media.jai.vectorbinarize.VectorBinarizeRIF
Error in registry file at line number #19
org.jaitools.media.jai.vectorize.VectorizeRIF
2022-01-27 08:47:43.254 SEVERE: geotools: error in EPSG database initialization. NoSuchAuthorityCodeException: No code "EPSG:4326" from authority "European Petroleum Survey Group" found for object of type "IdentifiedObject".
2022-01-27 08:47:43.256 INFO: loading plugin 'geotools-wfs' (version 26.1)
Error in registry file at line number #4
org.jaitools.media.jai.contour.ContourDescriptor
Error in registry file at line number #5
org.jaitools.media.jai.rangelookup.RangeLookupDescriptor
Error in registry file at line number #6
org.jaitools.media.jai.vectorbinarize.VectorBinarizeDescriptor
Error in registry file at line number #7
org.jaitools.media.jai.vectorize.VectorizeDescriptor
Error in registry file at line number #16
org.jaitools.media.jai.contour.ContourRIF
Error in registry file at line number #17
org.jaitools.media.jai.rangelookup.RangeLookupRIF
Error in registry file at line number #18
org.jaitools.media.jai.vectorbinarize.VectorBinarizeRIF
Error in registry file at line number #19
org.jaitools.media.jai.vectorize.VectorizeRIF
2022-01-27 08:47:43.265 SEVERE: geotools: error in EPSG database initialization. NoSuchAuthorityCodeException: No code "EPSG:4326" from authority "European Petroleum Survey Group" found for object of type "IdentifiedObject".

2022-01-27 14:27:40.585 INFO: loading plugin 'opendataservices' (version 0.6.20)
2022-01-27 14:27:42.919 INFO: GET https://josm.openstreetmap.de/mapkey/Maxar-Premium -> HTTP/1.1 200 (160 ms; 37 B)
2022-01-27 14:27:44.029 INFO: loading plugin 'ods-bag' (version 0.6.20)
2022-01-27 14:27:44.078 SEVERE: org.openstreetmap.josm.plugins.PluginException: An error occurred in plugin ods-bag. Cause: java.lang.reflect.InvocationTargetException. Cause: java.lang.ExceptionInInitializerError. Cause: java.lang.RuntimeException: org.opengis.referencing.NoSuchAuthorityCodeException: No code "EPSG:4326" from authority "European Petroleum Survey Group" found for object of type "IdentifiedObject".. Cause: org.opengis.referencing.NoSuchAuthorityCodeException: No code "EPSG:4326" from authority "European Petroleum Survey Group" found for object of type "IdentifiedObject".
org.openstreetmap.josm.plugins.PluginException: An error occurred in plugin ods-bag
        at org.openstreetmap.josm.plugins.PluginInformation.load(PluginInformation.java:388)
        at org.openstreetmap.josm.plugins.PluginHandler.loadPlugin(PluginHandler.java:812)
        at org.openstreetmap.josm.plugins.PluginHandler.loadPlugins(PluginHandler.java:897)
        at org.openstreetmap.josm.plugins.PluginHandler.loadLatePlugins(PluginHandler.java:949)
        at org.openstreetmap.josm.gui.MainApplication.loadLatePlugins(MainApplication.java:1224)
        at org.openstreetmap.josm.gui.MainApplication.mainJOSM(MainApplication.java:954)
        at org.openstreetmap.josm.gui.MainApplication$3.processArguments(MainApplication.java:281)
        at org.openstreetmap.josm.gui.MainApplication.main(MainApplication.java:739)
Caused by: java.lang.reflect.InvocationTargetException
        at java.base/jdk.internal.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)
        at java.base/jdk.internal.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:77)
        at java.base/jdk.internal.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)
        at java.base/java.lang.reflect.Constructor.newInstanceWithCaller(Constructor.java:499)
        at java.base/java.lang.reflect.Constructor.newInstance(Constructor.java:480)
        at org.openstreetmap.josm.plugins.PluginInformation.load(PluginInformation.java:383)
        ... 7 more
Caused by: java.lang.ExceptionInInitializerError
        at org.openstreetmap.josm.plugins.ods.bag.BagImportModule.<init>(BagImportModule.java:50)
        at org.openstreetmap.josm.plugins.ods.bag.BagImportPlugin.<init>(BagImportPlugin.java:8)
        ... 13 more
Caused by: java.lang.RuntimeException: org.opengis.referencing.NoSuchAuthorityCodeException: No code "EPSG:4326" from authority "European Petroleum Survey Group" found for object of type "IdentifiedObject".
        at org.openstreetmap.josm.plugins.ods.crs.CRSUtil.<clinit>(CRSUtil.java:36)
        ... 15 more
Caused by: org.opengis.referencing.NoSuchAuthorityCodeException: No code "EPSG:4326" from authority "European Petroleum Survey Group" found for object of type "IdentifiedObject".
        at org.geotools.referencing.factory.AbstractAuthorityFactory.noSuchAuthorityCode(AbstractAuthorityFactory.java:908)
        at org.geotools.referencing.factory.PropertyAuthorityFactory.getWKT(PropertyAuthorityFactory.java:294)
        at org.geotools.referencing.factory.PropertyAuthorityFactory.createCoordinateReferenceSystem(PropertyAuthorityFactory.java:364)
        at org.geotools.referencing.factory.BufferedAuthorityFactory.createCoordinateReferenceSystem(BufferedAuthorityFactory.java:761)
        at org.geotools.referencing.factory.AuthorityFactoryAdapter.createCoordinateReferenceSystem(AuthorityFactoryAdapter.java:811)
        at org.geotools.referencing.factory.FallbackAuthorityFactory.createCoordinateReferenceSystem(FallbackAuthorityFactory.java:652)
        at org.geotools.referencing.factory.AuthorityFactoryAdapter.createCoordinateReferenceSystem(AuthorityFactoryAdapter.java:811)
        at org.geotools.referencing.factory.ThreadedAuthorityFactory.createCoordinateReferenceSystem(ThreadedAuthorityFactory.java:667)
        at org.geotools.referencing.DefaultAuthorityFactory.createCoordinateReferenceSystem(DefaultAuthorityFactory.java:172)
        at org.geotools.referencing.CRS.decode(CRS.java:507)
        at org.geotools.referencing.CRS.decode(CRS.java:428)
        at org.openstreetmap.josm.plugins.ods.crs.CRSUtil.<clinit>(CRSUtil.java:34)
        ... 15 more
Last edited 4 months ago by SanderH (previous) (diff)

comment:10 Changed 4 months ago by skyper

Resolution: fixed
Status: closedreopened

Yes, same error on my system with java 17.

comment:11 Changed 4 months ago by taylor.smock

That is a slightly different error.

I consider the original bug fixed, since it isn't crashing JOSM at startup.

I'll still look into this problem, but I'll be testing against the opendata plugin.

comment:12 Changed 4 months ago by skyper

I am referring to only the geotools plugin, as opendata plugin depends on it, and this line:

2022-01-27 08:47:43.265 SEVERE: geotools: error in EPSG database initialization. NoSuchAuthorityCodeException: No code "EPSG:4326" from authority "European Petroleum Survey Group" found for object of type "IdentifiedObject".

Right, the plugin does not crash, right away, but something is still missing or not excluded. Do you prefer a new ticket?

comment:13 in reply to:  12 Changed 4 months ago by taylor.smock

I'm specifying that I'm using the opendata plugin for testing, since SanderH was using a plugin not in JOSM SVN/git (just to clarify).

And yes, something is still missing (which is why I'm still looking into the problem). No, you don't need to file a new ticket.

comment:14 Changed 4 months ago by taylor.smock

There was an ant task I missed.
ant merge-geotools-services

I was going to add it as a pre-compile dependency (so this doesn't happen again), but it looks like the generation has some issues.
Specifically, sometimes two class references get merged onto one line.

EDIT: See r35903/osm

Last edited 4 months ago by taylor.smock (previous) (diff)

comment:15 Changed 4 months ago by taylor.smock

In 35904/osm:

see #21803 (dist)

comment:16 Changed 4 months ago by taylor.smock

Resolution: fixed
Status: reopenedclosed

comment:17 Changed 4 months ago by skyper

Thanks. I still find these strange lines on the console:

2022-01-27 22:25:15.117 INFO: Warp/affine reduction enabled: true
Error in registry file at line number #4
org.jaitools.media.jai.contour.ContourDescriptor
Error in registry file at line number #5
org.jaitools.media.jai.rangelookup.RangeLookupDescriptor
Error in registry file at line number #6
org.jaitools.media.jai.vectorbinarize.VectorBinarizeDescriptor
Error in registry file at line number #7
org.jaitools.media.jai.vectorize.VectorizeDescriptor
Error in registry file at line number #16
org.jaitools.media.jai.contour.ContourRIF
Error in registry file at line number #17
org.jaitools.media.jai.rangelookup.RangeLookupRIF
Error in registry file at line number #18
org.jaitools.media.jai.vectorbinarize.VectorBinarizeRIF
Error in registry file at line number #19
org.jaitools.media.jai.vectorize.VectorizeRIF

comment:18 Changed 4 months ago by taylor.smock

I see them too. Unfortunately, I don't know what is causing them :(

comment:19 Changed 4 months ago by SanderH

Those errors seem to be an issue reported a few years ago on sourceforge with a hint on what's causing it: https://sourceforge.net/p/repast/mailman/repast-interest/thread/BLUPR09MB0899C08331FA68EB4CA64FE1DA510%40BLUPR09MB0899.namprd09.prod.outlook.com/

comment:20 Changed 4 months ago by skyper

Ticket #21818 has been marked as a duplicate of this ticket.

comment:21 Changed 4 months ago by taylor.smock

Ticket #21823 has been marked as a duplicate of this ticket.

Modify Ticket

Change Properties
Set your email in Preferences
Action
as closed The owner will remain Don-vip.
as The resolution will be set.
The resolution will be deleted.

Add Comment


E-mail address and name can be saved in the Preferences.

 
Note: See TracTickets for help on using tickets.